## stella 6.2

=== Makefile ===
##============================================================================
##
##   SSSS    tt          lll  lll
##  SS  SS   tt           ll   ll
##  SS     tttttt  eeee   ll   ll   aaaa
##   SSSS    tt   ee  ee  ll   ll      aa
##      SS   tt   eeeeee  ll   ll   aaaaa  --  "An Atari 2600 VCS Emulator"
##  SS  SS   tt   ee      ll   ll  aa  aa
##   SSSS     ttt  eeeee llll llll  aaaaa
##
## Copyright (c) 1995-2020 by Bradford W. Mott, Stephen Anthony
## and the Stella Team
##
## See the file "License.txt" for information on usage and redistribution of
## this file, and for a DISCLAIMER OF ALL WARRANTIES.
##============================================================================

#######################################################################
# Default compilation parameters. Normally don't edit these           #
#######################################################################

srcdir      ?= .

DEFINES     := -DSDL_SUPPORT -D_GLIBCXX_USE_CXX11_ABI=1
LDFLAGS     := -pthread
INCLUDES    :=
LIBS	    :=
OBJS	    :=
PROF        :=

MODULES     :=
MODULE_DIRS :=

DISTNAME    := stella-snapshot

# Load the make rules generated by configure
include config.mak

# Uncomment this for stricter compile time code verification
# CXXFLAGS+= -Werror

ifdef CXXFLAGS
  CXXFLAGS:= $(CXXFLAGS) -x c++
else
  CXXFLAGS:= -O2 -x c++
endif

CXXFLAGS+= -Wall -Wextra -Wno-unused-parameter

ifdef HAVE_GCC
  CXXFLAGS+= -Wno-multichar -Wunused -fno-rtti -Woverloaded-virtual -Wnon-virtual-dtor -std=c++14
endif

ifdef HAVE_CLANG
  CXXFLAGS+= -Wno-multichar -Wunused -fno-rtti -Woverloaded-virtual -Wnon-virtual-dtor -std=c++14
endif

ifdef CLANG_WARNINGS
  CXXFLAGS+= -Weverything -Wno-c++17-extensions  -Wno-c++98-compat-pedantic \
    -Wno-switch-enum -Wno-conversion -Wno-covered-switch-default \
    -Wno-inconsistent-missing-destructor-override -Wno-float-equal \
    -Wno-exit-time-destructors -Wno-global-constructors -Wno-weak-vtables \
    -Wno-four-char-constants -Wno-padded
endif

ifdef PROFILE
  PROF:= -pg -fprofile-arcs -ftest-coverage
  CXXFLAGS+= $(PROF)
endif

ifdef DEBUG
  CXXFLAGS += -g
else
  ifdef HAVE_GCC
    CXXFLAGS+= -fomit-frame-pointer
  endif

  ifdef HAVE_CLANG
    CXXFLAGS+= -fomit-frame-pointer
  endif
endif

#######################################################################
# Misc stuff - you should never have to edit this                     #
#######################################################################

ifdef STELLA_BUILD_ROOT
  OBJECT_ROOT := $(STELLA_BUILD_ROOT)/stella-out
else
  OBJECT_ROOT := out
endif
OBJECT_ROOT_PROFILE_GENERERATE := out.pgen
OBJECT_ROOT_PROFILE_USE := out.pgo

EXECUTABLE := stella$(EXEEXT)
EXECUTABLE_PROFILE_GENERATE := stella-pgo-generate$(EXEEXT)
EXECUTABLE_PROFILE_USE := stella-pgo$(EXEEXT)

PROFILE_DIR = $(CURDIR)/profile
PROFILE_OUT = $(PROFILE_DIR)/out
PROFILE_STAMP = profile.stamp

CXXFLAGS_PROFILE_GENERATE = $(CXXFLAGS)
CXXFLAGS_PROFILE_USE = $(CXXFLAGS)
LDFLAGS_PROFILE_GENERATE = $(LDFLAGS)
STELLA_PROFILE_GENERATE = $(BINARY_LOADER) ./$(EXECUTABLE_PROFILE_GENERATE) -profile \
	$(PROFILE_DIR)/128.bin:10 \
	$(PROFILE_DIR)/catharsis_theory.bin:60

ifdef HAVE_CLANG
	CXXFLAGS_PROFILE_GENERATE += -fprofile-generate=$(PROFILE_OUT)
	CXXFLAGS_PROFILE_USE += -fprofile-use=$(PROFILE_OUT)
	LDFLAGS_PROFILE_GENERATE += -fprofile-generate
	STELLA_PROFILE_GENERATE := \
		LLVM_PROFILE_FILE="$(PROFILE_OUT)/default.profraw" $(STELLA_PROFILE_GENERATE) && \
		$(LLVM_PROFDATA) merge -o $(PROFILE_OUT)/default.profdata $(PROFILE_OUT)/default.profraw
endif

ifdef HAVE_GCC
	CXXFLAGS_PROFILE_GENERATE += -fprofile-generate -fprofile-dir=$(PROFILE_OUT)
	CXXFLAGS_PROFILE_USE += -fprofile-use -fprofile-dir=$(PROFILE_OUT)
	LDFLAGS_PROFILE_GENERATE += -fprofile-generate
	STELLA_PROFILE_GENERATE := $(STELLA_PROFILE_GENERATE) && \
	  rm -fr $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_USE) && \
		mv $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_GENERERATE) $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_USE)
endif

all: $(EXECUTABLE)

pgo: $(EXECUTABLE_PROFILE_USE)

######################################################################
# Various minor settings
######################################################################

# The name for the directory used for dependency tracking
DEPDIR := .deps


######################################################################
# Module settings
######################################################################

MODULES := $(MODULES)

# After the game specific modules follow the shared modules
MODULES += \
	src/common \
	src/common/audio \
	src/common/tv_filters \
	src/emucore \
	src/emucore/tia \
	src/emucore/tia/frame-manager

######################################################################
# The build rules follow - normally you should have no need to
# touch whatever comes after here.
######################################################################

# Concat DEFINES and INCLUDES to form the CPPFLAGS
CPPFLAGS:= $(DEFINES) $(INCLUDES)

# Include the build instructions for all modules
-include $(addprefix $(srcdir)/, $(addsuffix /module.mk,$(MODULES)))

# Depdir information
DEPDIRS = $(addsuffix /$(DEPDIR),$(MODULE_DIRS))
DEPFILES =

OBJ=$(addprefix $(OBJECT_ROOT)/,$(OBJS))
OBJ_PROFILE_GENERATE=$(addprefix $(OBJECT_ROOT_PROFILE_GENERERATE)/,$(OBJS))
OBJ_PROFILE_USE=$(addprefix $(OBJECT_ROOT_PROFILE_USE)/,$(OBJS))

# The build rule for the Stella executable
$(EXECUTABLE): $(OBJ)
	$(LD) $(LDFLAGS) $(PRE_OBJS_FLAGS) $+ $(POST_OBJS_FLAGS) $(LIBS) $(PROF) -o $@

$(EXECUTABLE_PROFILE_GENERATE): $(OBJ_PROFILE_GENERATE)
	$(LD) $(LDFLAGS_PROFILE_GENERATE) $(PRE_OBJS_FLAGS) $+ $(POST_OBJS_FLAGS) $(LIBS) $(PROF) -o $@

$(EXECUTABLE_PROFILE_USE): $(OBJ_PROFILE_USE)
	$(LD) $(LDFLAGS) $(PRE_OBJS_FLAGS) $+ $(POST_OBJS_FLAGS) $(LIBS) $(PROF) -o $@

distclean: clean
	$(RM_REC) $(DEPDIRS)
	$(RM) build.rules config.h config.mak config.log

clean:
	-$(RM) -fr \
		$(OBJECT_ROOT) $(OBJECT_ROOT_PROFILE_GENERERATE) $(OBJECT_ROOT_PROFILE_USE) \
		$(EXECUTABLE) $(EXECUTABLE_PROFILE_GENERATE) $(EXECUTABLE_PROFILE_USE) \
		$(PROFILE_OUT) $(PROFILE_STAMP)

.PHONY: all clean dist distclean

.SUFFIXES: .cxx

define create_dir
$(MKDIR) -p $(*D)/$(DEPDIR)
$(MKDIR) -p $(@D)
endef

define merge_dep
$(ECHO) "$(*D)/" > $(*D)/$(DEPDIR)/$(*F).d
$(CAT) "$(*D)/$(DEPDIR)/$(*F).d2" >> "$(*D)/$(DEPDIR)/$(*F).d"
$(RM) "$(*D)/$(DEPDIR)/$(*F).d2"
endef

ifndef CXX_UPDATE_DEP_FLAG
# If you use GCC, disable the above and enable this for intelligent
# dependency tracking.
CXX_UPDATE_DEP_FLAG = -Wp,-MMD,"$(*D)/$(DEPDIR)/$(*F).d2"

$(OBJECT_ROOT)/%.o: %.cxx
	$(create_dir)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $@
	$(merge_dep)

$(OBJECT_ROOT)/%.o: %.c
	$(create_dir)
	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $@
	$(merge_dep)

$(OBJECT_ROOT_PROFILE_GENERERATE)/%.pgen.o: %.cxx
	$(create_dir)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@
	$(merge_dep)

$(OBJECT_ROOT_PROFILE_GENERERATE)/%.pgen.o: %.cxx
	$(create_dir)
	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@
	$(merge_dep)

$(OBJECT_ROOT_PROFILE_USE)/%.pgo.o: %.cxx $(PROFILE_STAMP)
	$(create_dir)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@
	$(merge_dep)

$(OBJECT_ROOT_PROFILE_USE)/%.pgo.o: %.cxx $(PROFILE_STAMP)
	$(create_dir)
	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@
	$(merge_dep)

else
# If you even have GCC 3.x, you can use this build rule, which is safer; the above
# rule can get you into a bad state if you Ctrl-C at the wrong moment.
# Also, with this GCC inserts additional dummy rules for the involved headers,
# which ensures a smooth compilation even if said headers become obsolete.
$(OBJECT_ROOT)/%.o: %.cxx
	$(create_dir)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $@

$(OBJECT_ROOT)/%.o: %.c
	$(create_dir)
	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $@

$(OBJECT_ROOT_PROFILE_GENERERATE)/%.o: %.cxx
	$(create_dir)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@

$(OBJECT_ROOT_PROFILE_GENERERATE)/%.o: %.c
	$(create_dir)
	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@

$(OBJECT_ROOT_PROFILE_USE)/%.o: %.cxx $(PROFILE_STAMP)
	$(create_dir)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@

$(OBJECT_ROOT_PROFILE_USE)/%.o: %.c $(PROFILE_STAMP)
	$(create_dir)
	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@

endif

# Include the dependency tracking files. We add /dev/null at the end
# of the list to avoid a warning/error if no .d file exist
-include $(wildcard $(addsuffix /*.d,$(DEPDIRS))) /dev/null

$(PROFILE_STAMP): $(EXECUTABLE_PROFILE_GENERATE)
	-rm -fr $(PROFILE_OUT)
	$(STELLA_PROFILE_GENERATE)
	touch $(PROFILE_STAMP)

# check if configure has been run or has been changed since last run
config.mak: $(srcdir)/configure
	@echo "You need to run ./configure before you can run make"
	@echo "Either you haven't run it before or it has changed."
	@exit 1

install: all
	$(INSTALL) -d "$(DESTDIR)$(BINDIR)"
	$(INSTALL) -c -m 755 "$(srcdir)/stella$(EXEEXT)" "$(DESTDIR)$(BINDIR)/stella$(EXEEXT)"
	$(INSTALL) -d "$(DESTDIR)$(DOCDIR)"
	$(INSTALL) -c -m 644 "$(srcdir)/Announce.txt" "$(srcdir)/Changes.txt" "$(srcdir)/Copyright.txt" "$(srcdir)/License.txt" "$(srcdir)/README-SDL.txt" "$(srcdir)/Readme.txt" "$(srcdir)/Todo.txt" "$(srcdir)/docs/index.html" "$(srcdir)/docs/debugger.html" "$(DESTDIR)$(DOCDIR)/"
	$(INSTALL) -d "$(DESTDIR)$(DOCDIR)/graphics"
	$(INSTALL) -c -m 644 $(wildcard $(srcdir)/docs/graphics/*.png) "$(DESTDIR)$(DOCDIR)/graphics"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/applications"
	$(INSTALL) -c -m 644 "$(srcdir)/src/unix/stella.desktop" "$(DESTDIR)$(DATADIR)/applications"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/icons/hicolor/16x16/apps"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/icons/hicolor/22x22/apps"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/icons/hicolor/24x24/apps"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/icons/hicolor/32x32/apps"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/icons/hicolor/48x48/apps"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/icons/hicolor/64x64/apps"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/icons/hicolor/128x128/apps"
	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-16x16.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/16x16/apps/stella.png"
	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-22x22.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/22x22/apps/stella.png"
	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-24x24.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/24x24/apps/stella.png"
	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-32x32.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/32x32/apps/stella.png"
	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-48x48.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/48x48/apps/stella.png"
	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-64x64.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/64x64/apps/stella.png"
	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-128x128.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/128x128/apps/stella.png"

install-strip: install
	$(STRIP) stella$(EXEEXT)

uninstall:
	rm -f  "$(DESTDIR)$(BINDIR)/stella$(EXEEXT)"
	rm -rf "$(DESTDIR)$(DOCDIR)/"
	rm -f  "$(DESTDIR)$(DATADIR)/applications/stella.desktop"
	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/16x16/apps/stella.png"
	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/22x22/apps/stella.png"
	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/24x24/apps/stella.png"
	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/32x32/apps/stella.png"
	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/48x48/apps/stella.png"
	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/64x64/apps/stella.png"
	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/128x128/apps/stella.png"

# Special rule for M6502.ins, generated from m4 (there's probably a better way to do this ...)

=== src/libretro/Makefile ===
DEBUG = 0
HAVE_EXCEPTIONS = 1
HAVE_STRINGS_H = 1

LTO ?= -flto
SPACE :=
SPACE := $(SPACE) $(SPACE)
BACKSLASH :=
BACKSLASH := \$(BACKSLASH)
filter_out1 = $(filter-out $(firstword $1),$1)
filter_out2 = $(call filter_out1,$(call filter_out1,$1))

ifeq ($(platform),)
   platform = unix
   ifeq ($(shell uname -s),)
      platform = win
   else ifneq ($(findstring MINGW,$(shell uname -s)),)
      platform = win
   else ifneq ($(findstring Darwin,$(shell uname -s)),)
      platform = osx
      arch = intel
      ifeq ($(shell uname -p),powerpc)
         arch = ppc
      endif
   else ifneq ($(findstring win,$(shell uname -s)),)
      platform = win
   endif
else ifneq (,$(findstring armv,$(platform)))
   ifeq (,$(findstring classic_,$(platform)))
      override platform += unix
   endif
else ifneq (,$(findstring rpi,$(platform)))
   override platform += unix
endif

ifneq ($(platform), osx)
   ifeq ($(findstring Haiku,$(shell uname -a)),)
      PTHREAD_FLAGS = -lpthread
   endif
endif

TARGET_NAME = stella


ifeq (,$(findstring msvc,$(platform)))
   CXXFLAGS += -std=c++14 -fno-rtti
   LIBS := -lm
else
   LIBS :=
endif

GIT_VERSION := " $(shell git rev-parse --short HEAD || echo unknown)"
ifneq ($(GIT_VERSION)," unknown")
   CXXFLAGS += -DGIT_VERSION=\"$(GIT_VERSION)\"
endif

# Unix
ifneq (,$(findstring unix,$(platform)))
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS) -static-libgcc -static-libstdc++
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   ifneq ($(findstring SunOS,$(shell uname -a)),)
      CXX = g++
      SHARED := -shared -z defs
   else
      SHARED := -shared -Wl,--version-script=link.T -Wl,-z,defs
   endif

   # ARM
   ifneq (,$(findstring armv,$(platform)))
      CXXFLAGS += -DARM
   # Raspberry Pi
   else ifneq (,$(findstring rpi,$(platform)))
      CXXFLAGS += -DARM
   endif

# OS X
else ifeq ($(platform), osx)
   CXXFLAGS += $(LTO) $(PTHREAD_FLAGS) -stdlib=libc++
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS) -stdlib=libc++
   TARGET := $(TARGET_NAME)_libretro.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   arch = intel
   ifeq ($(shell uname -p),powerpc)
      arch = ppc
   endif
   ifeq ($(arch),ppc)
      CXXFLAGS += -DBLARGG_BIG_ENDIAN=1 -D__ppc__
   endif
   OSXVER = $(shell sw_vers -productVersion | cut -d. -f 2)
   OSX_GT_MOJAVE = $(shell (( $(OSXVER) >= 14)) && echo "YES")
   ifneq ($(OSX_GT_MOJAVE),YES)
      #this breaks compiling on Mac OS Mojave
      fpic += -mmacosx-version-min=10.7
   endif

# Nintendo Switch (libnx)
else ifeq ($(platform), libnx)
   include $(DEVKITPRO)/libnx/switch_rules
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   DEFINES := -DSWITCH=1 -D__SWITCH__ -DARM
   CXXFLAGS := $(DEFINES) -fPIE -I$(LIBNX)/include/ -ffunction-sections -fdata-sections -ftls-model=local-exec -specs=$(LIBNX)/switch.specs
   CXXFLAGS += -march=armv8-a -mtune=cortex-a57 -mtp=soft -mcpu=cortex-a57+crc+fp+simd -ffast-math $(ASFLAGS)
   STATIC_LINKING = 1

# Classic Platforms ####################
# Platform affix = classic_<ISA>_<µARCH>
# Help at https://modmyclassic.com/comp

# (armv7 a7, hard point, neon based) ###
# NESC, SNESC, C64 mini
else ifeq ($(platform), classic_armv7_a7)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
   CXXFLAGS += -Ofast \
               -flto=4 -fwhole-program -fuse-linker-plugin \
               -fdata-sections -ffunction-sections -Wl,--gc-sections \
               -fno-stack-protector -fno-ident -fomit-frame-pointer \
               -falign-functions=1 -falign-jumps=1 -falign-loops=1 \
               -fno-unwind-tables -fno-asynchronous-unwind-tables -fno-unroll-loops \
               -fmerge-all-constants -fno-math-errno \
              -marm -mtune=cortex-a7 -mfpu=neon-vfpv4 -mfloat-abi=hard
   HAVE_NEON = 1
   ARCH = arm
   BUILTIN_GPU = neon
   USE_DYNAREC = 1
   ifeq ($(shell echo `$(CXX) -dumpversion` "< 4.9" | bc -l), 1)
      CXXFLAGS += -march=armv7-a
   else
      CXXFLAGS += -march=armv7ve
      # If gcc is 5.0 or later
      ifeq ($(shell echo `$(CXX) -dumpversion` ">= 5" | bc -l), 1)
         LDFLAGS += -static-libgcc -static-libstdc++
      endif
   endif

# iOS
else ifneq (,$(findstring ios,$(platform)))
   CXXFLAGS += $(LTO) $(PTHREAD_FLAGS) -stdlib=libc++
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS) -stdlib=libc++
   TARGET := $(TARGET_NAME)_libretro_ios.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   ifeq ($(IOSSDK),)
      IOSSDK := $(shell xcodebuild -version -sdk iphoneos Path)
   endif
   ifeq ($(platform),ios-arm64)
      CXX = clang++ -arch arm64 -isysroot $(IOSSDK)
   else
      CXX = clang++ -arch armv7 -isysroot $(IOSSDK)
   endif
   CXXFLAGS += -DIOS
   CXXFLAGS += -DARM
   ifeq ($(platform),$(filter $(platform),ios9 ios-arm64))
      CXX      += -miphoneos-version-min=8.0
      CXXFLAGS += -miphoneos-version-min=8.0
   else
      CXX      += -miphoneos-version-min=5.0
      CXXFLAGS += -miphoneos-version-min=5.0
   endif

# tvOS
else ifeq ($(platform), tvos-arm64)
   CXXFLAGS += $(LTO) $(PTHREAD_FLAGS) -stdlib=libc++
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS) -stdlib=libc++
   TARGET := $(TARGET_NAME)_libretro_tvos.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   ifeq ($(IOSSDK),)
      IOSSDK := $(shell xcodebuild -version -sdk appletvos Path)
   endif
   CXXFLAGS += -DIOS
   CXXFLAGS += -DARM

# Theos
else ifeq ($(platform), theos_ios)
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO)
   DEPLOYMENT_IOSVERSION = 5.0
   TARGET = iphone:latest:$(DEPLOYMENT_IOSVERSION)
   ARCHS = armv7 armv7s
   TARGET_IPHONEOS_DEPLOYMENT_VERSION=$(DEPLOYMENT_IOSVERSION)
   THEOS_BUILD_DIR := objs
   include $(THEOS)/makefiles/common.mk
   LIBRARY_NAME = $(TARGET_NAME)_libretro_ios

# QNX
else ifeq ($(platform), qnx)
   TARGET := $(TARGET_NAME)_libretro_$(platform).so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T
   CXX = QCC -Vgcc_notarmv7le
   AR = QCC -Vgcc_ntoarmv7le
   CXXFLAGS += -D__BLACKBERRY_QNX__
   CXXFLAGS += -DARM
   HAVE_EXCEPTIONS = 1

# Vita
else ifeq ($(platform), vita)
   CXXFLAGS += $(LTO) $(PTHREAD_FLAGS)
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS)
   TARGET := $(TARGET_NAME)_libretro_$(platform).so
   fpic := -fPIC
   CXX = arm-vita-eabi-g++$(EXE_EXT)
   AR = arm-vita-eabi-ar$(EXE_EXT)
   CXXFLAGS += -DVITA
   CXXFLAGS += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int
   HAVE_EXCEPTIONS = 1

# PS3
else ifneq (,$(filter $(platform), ps3 sncps3 psl1ght))
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CXXFLAGS += -DBLARGG_BIG_ENDIAN=1 -D__ppc__
   STATIC_LINKING = 1
   HAVE_STRINGS_H = 0

   # sncps3
   ifneq (,$(findstring sncps3,$(platform)))
      TARGET := $(TARGET_NAME)_libretro_ps3.a
      CXX = $(CELL_SDK)/host-win32/sn/bin/ps3ppusnc.exe
      AR = $(CELL_SDK)/host-win32/sn/bin/ps3snarl.exe
   # PS3
   else ifneq (,$(findstring ps3,$(platform)))
      CXX = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-g++.exe
      AR = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-ar.exe
   # Lightweight PS3 Homebrew SDK
   else ifneq (,$(findstring psl1ght,$(platform)))
      CXX = $(PS3DEV)/ppu/bin/ppu-g++$(EXE_EXT)
      AR = $(PS3DEV)/ppu/bin/ppu-ar$(EXE_EXT)
   endif

# CTR (3DS)
else ifeq ($(platform), ctr)
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CXX = $(DEVKITARM)/bin/arm-none-eabi-g++$(EXE_EXT)
   AR = $(DEVKITARM)/bin/arm-none-eabi-ar$(EXE_EXT)
   ENDIANNESS_DEFINES := -DLSB_FIRST
   CXXFLAGS += -DARM11 -D_3DS
   CXXFLAGS += -march=armv6k -mtune=mpcore -mfloat-abi=hard
   CXXFLAGS += -mword-relocations
   CXXFLAGS += -fomit-frame-pointer -fstrict-aliasing -ffast-math
   CXXFLAGS += -fno-rtti
   CXXFLAGS += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int
   STATIC_LINKING = 1
   LOAD_FROM_MEMORY = 0

# Xbox 360
else ifeq ($(platform), xenon)
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO)
   TARGET := $(TARGET_NAME)_libretro_xenon360.a
   CXX = xenon-g++$(EXE_EXT)
   AR = xenon-ar$(EXE_EXT)
   CXXFLAGS += -D__LIBXENON__ -m32 -D__ppc__
   LIBS := $(PTHREAD_FLAGS)
   STATIC_LINKING = 1

# Nintendo Game Cube / Wii / WiiU
else ifneq (,$(filter $(platform), ngc wii wiiu))
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
   AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
   CXXFLAGS += -mcpu=750 -meabi -mhard-float -DBLARGG_BIG_ENDIAN=1 -D__ppc__
   CXXFLAGS += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int
   STATIC_LINKING = 1

   # Nintendo WiiU
   ifneq (,$(findstring wiiu,$(platform)))
      CXXFLAGS += -mwup
   # Nintendo Wii
   else ifneq (,$(findstring wii,$(platform)))
      CXXFLAGS += -DGEKKO -mrvl
   # Nintendo Game Cube
   else ifneq (,$(findstring ngc,$(platform)))
      CXXFLAGS += -DGEKKO -mrvl
   endif

# Emscripten
else ifeq ($(platform), emscripten)
   TARGET := $(TARGET_NAME)_libretro_$(platform).bc
   STATIC_LINKING = 1
   CXXFLAGS += $(PTHREAD_FLAGS) -std=c++14
   LDFLAGS += $(PTHREAD_FLAGS) -std=c++14

# Genode
else ifeq ($(platform), genode)
   TARGET  := $(TARGET_NAME)_libretro.lib.so
   PKG_CONFIG := genode-lib genode-stdcxx
   CXXFLAGS += -D__GENODE__
   CXXFLAGS += $(shell pkg-config --cflags $(PKG_CONFIG))

   LDFLAGS += -shared --version-script=link.T
   LDFLAGS += $(shell pkg-config --libs $(PKG_CONFIG))

   CXX = $(shell pkg-config genode-base --variable=cxx)
   LD  = $(shell pkg-config genode-base --variable=ld)
   AR  = $(shell pkg-config genode-base --variable=ar) -rcs

# Windows MSVC 2003 Xbox 1
else ifeq ($(platform), xbox1_msvc2003)
   CXXFLAGS += -D__WIN32__
   TARGET := $(TARGET_NAME)_libretro_xdk1.lib
   MSVCBINDIRPREFIX = $(XDK)/xbox/bin/vc71
   CXX  = "$(MSVCBINDIRPREFIX)/CL.exe"
   LD   = "$(MSVCBINDIRPREFIX)/lib.exe"

   export INCLUDE := $(XDK)/xbox/include
   export LIB := $(XDK)/xbox/lib
   PSS_STYLE :=2
   CXXFLAGS += -D_XBOX -D_XBOX1
   STATIC_LINKING=1
   HAS_GCC := 0

# Windows MSVC 2010 Xbox 360
else ifeq ($(platform), xbox360_msvc2010)
   CXXFLAGS += -D__WIN32__
   TARGET := $(TARGET_NAME)_libretro_xdk360.lib
   MSVCBINDIRPREFIX = $(XEDK)/bin/win32
   CXX  = "$(MSVCBINDIRPREFIX)/cl.exe"
   LD   = "$(MSVCBINDIRPREFIX)/lib.exe"

   export INCLUDE := $(XEDK)/include/xbox
   export LIB := $(XEDK)/lib/xbox
   PSS_STYLE :=2
   CXXFLAGS += -D_XBOX -D_XBOX360
   STATIC_LINKING=1
   HAS_GCC := 0

# Windows MSVC 2017 all architectures
else ifneq (,$(findstring windows_msvc2017,$(platform)))
   CXXFLAGS += -D__WIN32__

   PlatformSuffix = $(subst windows_msvc2017_,,$(platform))
   ifneq (,$(findstring desktop,$(PlatformSuffix)))
      WinPartition = desktop
      MSVC2017CompileFlags = -DWINAPI_FAMILY=WINAPI_FAMILY_DESKTOP_APP
      LDFLAGS += -MANIFEST -LTCG:incremental -NXCOMPAT -DYNAMICBASE -DEBUG -OPT:REF -INCREMENTAL:NO -SUBSYSTEM:WINDOWS -MANIFESTUAC:"level='asInvoker' uiAccess='false'" -OPT:ICF -ERRORREPORT:PROMPT -NOLOGO -TLBID:1
      LIBS += kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib
   else ifneq (,$(findstring uwp,$(PlatformSuffix)))
      WinPartition = uwp
      MSVC2017CompileFlags = -DWINAPI_FAMILY=WINAPI_FAMILY_APP -D_WINDLL -D_UNICODE -DUNICODE -D__WRL_NO_DEFAULT_LIB__ -ZW:nostdlib -EHsc
      LDFLAGS += -APPCONTAINER -NXCOMPAT -DYNAMICBASE -MANIFEST:NO -LTCG -OPT:REF -SUBSYSTEM:CONSOLE -MANIFESTUAC:NO -OPT:ICF -ERRORREPORT:PROMPT -NOLOGO -TLBID:1 -DEBUG:FULL -WINMD:NO
      LIBS += WindowsApp.lib
   endif

   # Specific to this core
   MSVC2017CompileFlags += -D__WIN32__ /std:c++17

   CXX = cl.exe
   CXXFLAGS += $(MSVC2017CompileFlags)

   TargetArchMoniker = $(subst $(WinPartition)_,,$(PlatformSuffix))

   reg_query = $(call filter_out2,$(subst $2,,$(shell reg query "$2" -v "$1" 2>nul)))
   fix_path = $(subst $(SPACE),\ ,$(subst \,/,$1))

   ProgramFiles86w := $(shell cmd //c "echo %PROGRAMFILES(x86)%")
   ProgramFiles86 := $(shell cygpath "$(ProgramFiles86w)")

   WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Microsoft SDKs\Windows\v10.0)

=== src/tools/evdev-joystick/Makefile ===
all : evdev-joystick

evdev-joystick: evdev-joystick.c
	$(CC) -Wall -O2 -o evdev-joystick evdev-joystick.c

install: evdev-joystick 80-stelladaptor-joystick.rules
	install -s evdev-joystick /usr/local/bin/
	install -m 644 80-stelladaptor-joystick.rules /etc/udev/rules.d/

clean:
	rm -rf evdev-joystick

=== debian/changelog ===
stella (6.2-1) unstable; urgency=medium

  [ Stephen Kitt ]
  * New upstream release.

  [ Helmut Grohne ]
  * Fix FTCBFS: Pass both --host and CXX to configure. Closes: #961773.

 -- Stephen Kitt <skitt@debian.org>  Mon, 08 Jun 2020 13:17:55 +0200

## stella 6.2.1

=== Makefile ===
--- 
+++ 
@@ -96,7 +96,7 @@
 EXECUTABLE_PROFILE_GENERATE := stella-pgo-generate$(EXEEXT)
 EXECUTABLE_PROFILE_USE := stella-pgo$(EXEEXT)
 
-PROFILE_DIR = $(CURDIR)/profile
+PROFILE_DIR = $(CURDIR)/test/roms/profile
 PROFILE_OUT = $(PROFILE_DIR)/out
 PROFILE_STAMP = profile.stamp

=== debian/changelog ===
stella (6.2.1-1) unstable; urgency=medium

  * New upstream release.
  * Fix a spelling mistake (thanks Lintian).

 -- Stephen Kitt <skitt@debian.org>  Sun, 21 Jun 2020 18:13:40 +0200

=== debian/control ===
Source: stella
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Stephen Kitt <skitt@debian.org>
Section: otherosfs
Priority: optional
Build-Depends: debhelper-compat (= 12),
               libpng-dev,
               libsdl2-dev,
               zlib1g-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/games-team/stella/tree/experimental
Vcs-Git: https://salsa.debian.org/games-team/stella.git -b experimental
Homepage: https://stella-emu.github.io
Rules-Requires-Root: no

Package: stella
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: joystick (>= 1:1.5.1)
Pre-Depends: ${misc:Pre-Depends}
Description: Atari 2600 Emulator for SDL & the X Window System
 Stella is a portable emulator of the old Atari 2600 video-game
 console. You can play most Atari 2600 games with it.
 .
 Stella's features include:
  * emulation of Atari 2600 joysticks, keyboards, paddles and driving
    controllers using the host system's input peripherals;
  * emulation of trackballs, joysticks, booster grips, driving
    controllers and the Amiga Mouse using the host system's mouse;
  * support for real Atari 2600 controllers using the Stelladaptor,
    2600-daptor or 2600-daptor II;
  * support for real Atari 7800 controllers using the 2600-daptor II;
  * support for the speech portion of a real AtariVox device;
  * support for Supercharger single-load and multi-load games;
  * emulation of CRT TV features, including texturing, colour bleed,
    RF noise and phosphor burn-off (requires OpenGL).
 .
 An extensive debugger is included, with the Distella disassembler.
 .
 Note that this is not isee systems' STELLA modeling, simulation and
 analysis tool.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk
DPKG_EXPORT_BUILDTOOLS=1
-include /usr/share/dpkg/buildtools.mk

%:
	dh $@

override_dh_auto_clean:
# Generate the minimal config.mak required for "make distclean"
	test -f config.mak || echo "RM_REC := rm -f -r" > config.mak
	dh_auto_clean

override_dh_auto_configure:
	./configure --prefix=/usr $(if $(filter $(DEB_BUILD_ARCH),$(DEB_HOST_ARCH)),,--host=$(DEB_HOST_GNU_TYPE))

override_dh_auto_install:
	dh_auto_install
	# This is also installed as the upstream changelog
	rm $(CURDIR)/debian/stella/usr/share/doc/stella/Changes.txt
	# This is overridden by the copyright file
	rm $(CURDIR)/debian/stella/usr/share/doc/stella/License.txt

## stella 6.3

=== debian/changelog ===
stella (6.3-1) unstable; urgency=medium

  * New upstream release.
  * Switch to debhelper compatibility level 13.

 -- Stephen Kitt <skitt@debian.org>  Fri, 16 Oct 2020 16:12:06 +0200

## stella 6.4

=== Makefile ===
--- 
+++ 
@@ -78,6 +78,11 @@
   ifdef HAVE_CLANG
     CXXFLAGS+= -fomit-frame-pointer
   endif
+endif
+
+ifdef RELEASE
+  CXXFLAGS += -flto
+  LDFLAGS += -flto
 endif
 
 #######################################################################
@@ -326,4 +331,3 @@
 	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/64x64/apps/stella.png"
 	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/128x128/apps/stella.png"
 
-# Special rule for M6502.ins, generated from m4 (there's probably a better way to do this ...)

=== debian/changelog ===
stella (6.4-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Tue, 03 Nov 2020 22:34:02 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Stephen Kitt <skitt@debian.org>
 Section: otherosfs
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libpng-dev,
                libsdl2-dev,
                zlib1g-dev

## stella 6.5

=== debian/changelog ===
stella (6.5-1) unstable; urgency=medium

  * New upstream release.
  * Point to the main branch.
  * Standards-Version 4.5.1, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sun, 10 Jan 2021 19:32:09 +0100

## stella 6.5.1

=== src/libretro/Makefile ===
--- 
+++ 
@@ -43,7 +43,7 @@
 
 
 ifeq (,$(findstring msvc,$(platform)))
-   CXXFLAGS += -std=c++14 -fno-rtti
+   CXXFLAGS += -std=c++17 -fno-rtti
    LIBS := -lm
 else
    LIBS :=
@@ -101,7 +101,7 @@
    include $(DEVKITPRO)/libnx/switch_rules
    TARGET := $(TARGET_NAME)_libretro_$(platform).a
    DEFINES := -DSWITCH=1 -D__SWITCH__ -DARM
-   CXXFLAGS := $(DEFINES) -fPIE -I$(LIBNX)/include/ -ffunction-sections -fdata-sections -ftls-model=local-exec -specs=$(LIBNX)/switch.specs
+   CXXFLAGS += $(DEFINES) -fPIE -I$(LIBNX)/include/ -ffunction-sections -fdata-sections -ftls-model=local-exec -specs=$(LIBNX)/switch.specs
    CXXFLAGS += -march=armv8-a -mtune=cortex-a57 -mtp=soft -mcpu=cortex-a57+crc+fp+simd -ffast-math $(ASFLAGS)
    STATIC_LINKING = 1
 
@@ -282,8 +282,8 @@
 else ifeq ($(platform), emscripten)
    TARGET := $(TARGET_NAME)_libretro_$(platform).bc
    STATIC_LINKING = 1
-   CXXFLAGS += $(PTHREAD_FLAGS) -std=c++14
-   LDFLAGS += $(PTHREAD_FLAGS) -std=c++14
+   CXXFLAGS += $(PTHREAD_FLAGS) -std=c++17
+   LDFLAGS += $(PTHREAD_FLAGS) -std=c++17
 
 # Genode
 else ifeq ($(platform), genode)

=== debian/changelog ===
stella (6.5.1-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Thu, 04 Feb 2021 22:12:57 +0100

## stella 6.5.2

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 ##  SS  SS   tt   ee      ll   ll  aa  aa
 ##   SSSS     ttt  eeeee llll llll  aaaaa
 ##
-## Copyright (c) 1995-2020 by Bradford W. Mott, Stephen Anthony
+## Copyright (c) 1995-2021 by Bradford W. Mott, Stephen Anthony
 ## and the Stella Team
 ##
 ## See the file "License.txt" for information on usage and redistribution of
@@ -40,49 +40,62 @@
 # CXXFLAGS+= -Werror
 
 ifdef CXXFLAGS
+  CFLAGS:= $(CXXFLAGS)
   CXXFLAGS:= $(CXXFLAGS) -x c++
 else
   CXXFLAGS:= -O2 -x c++
+  CFLAGS:= -O2
 endif
 
 CXXFLAGS+= -Wall -Wextra -Wno-unused-parameter
+CFLAGS+= -Wall -Wextra -Wno-unused-parameter
 
 ifdef HAVE_GCC
-  CXXFLAGS+= -Wno-multichar -Wunused -fno-rtti -Woverloaded-virtual -Wnon-virtual-dtor -std=c++14
+  CXXFLAGS+= -Wno-multichar -Wunused -Woverloaded-virtual -Wnon-virtual-dtor -std=c++17
+  CFLAGS+= -Wno-multichar -Wunused
 endif
 
 ifdef HAVE_CLANG
-  CXXFLAGS+= -Wno-multichar -Wunused -fno-rtti -Woverloaded-virtual -Wnon-virtual-dtor -std=c++14
+  CXXFLAGS+= -Wno-multichar -Wunused -Woverloaded-virtual -Wnon-virtual-dtor -std=c++17
+  CFLAGS+= -Wno-multichar -Wunused
 endif
 
 ifdef CLANG_WARNINGS
-  CXXFLAGS+= -Weverything -Wno-c++17-extensions  -Wno-c++98-compat-pedantic \
+  EXTRA_WARN=-Weverything -Wno-c++17-extensions  -Wno-c++98-compat-pedantic \
     -Wno-switch-enum -Wno-conversion -Wno-covered-switch-default \
     -Wno-inconsistent-missing-destructor-override -Wno-float-equal \
     -Wno-exit-time-destructors -Wno-global-constructors -Wno-weak-vtables \
     -Wno-four-char-constants -Wno-padded
+
+  CXXFLAGS+= $(EXTRA_WARN)
+  CFLAGS+= $(EXTRA_WARN)
 endif
 
 ifdef PROFILE
   PROF:= -pg -fprofile-arcs -ftest-coverage
   CXXFLAGS+= $(PROF)
+  CFLAGS+= $(PROF)
 endif
 
 ifdef DEBUG
   CXXFLAGS += -g
+  CFLAGS += -g
 else
   ifdef HAVE_GCC
     CXXFLAGS+= -fomit-frame-pointer
+    CFLAGS+= -fomit-frame-pointer
   endif
 
   ifdef HAVE_CLANG
     CXXFLAGS+= -fomit-frame-pointer
+    CFLAGS+= -fomit-frame-pointer
   endif
 endif
 
 ifdef RELEASE
-  CXXFLAGS += -flto
-  LDFLAGS += -flto
+  CXXFLAGS += -flto -fno-rtti
+  CFLAGS += -flto
+  LDFLAGS += -flto -fno-rtti
 endif
 
 #######################################################################
@@ -107,6 +120,8 @@
 
 CXXFLAGS_PROFILE_GENERATE = $(CXXFLAGS)
 CXXFLAGS_PROFILE_USE = $(CXXFLAGS)
+CFLAGS_PROFILE_GENERATE = $(CFLAGS)
+CFLAGS_PROFILE_USE = $(CFLAGS)
 LDFLAGS_PROFILE_GENERATE = $(LDFLAGS)
 STELLA_PROFILE_GENERATE = $(BINARY_LOADER) ./$(EXECUTABLE_PROFILE_GENERATE) -profile \
 	$(PROFILE_DIR)/128.bin:10 \
@@ -115,6 +130,8 @@
 ifdef HAVE_CLANG
 	CXXFLAGS_PROFILE_GENERATE += -fprofile-generate=$(PROFILE_OUT)
 	CXXFLAGS_PROFILE_USE += -fprofile-use=$(PROFILE_OUT)
+	CFLAGS_PROFILE_GENERATE += -fprofile-generate=$(PROFILE_OUT)
+	CFLAGS_PROFILE_USE += -fprofile-use=$(PROFILE_OUT)
 	LDFLAGS_PROFILE_GENERATE += -fprofile-generate
 	STELLA_PROFILE_GENERATE := \
 		LLVM_PROFILE_FILE="$(PROFILE_OUT)/default.profraw" $(STELLA_PROFILE_GENERATE) && \
@@ -124,6 +141,8 @@
 ifdef HAVE_GCC
 	CXXFLAGS_PROFILE_GENERATE += -fprofile-generate -fprofile-dir=$(PROFILE_OUT)
 	CXXFLAGS_PROFILE_USE += -fprofile-use -fprofile-dir=$(PROFILE_OUT)
+	CFLAGS_PROFILE_GENERATE += -fprofile-generate -fprofile-dir=$(PROFILE_OUT)
+	CFLAGS_PROFILE_USE += -fprofile-use -fprofile-dir=$(PROFILE_OUT)
 	LDFLAGS_PROFILE_GENERATE += -fprofile-generate
 	STELLA_PROFILE_GENERATE := $(STELLA_PROFILE_GENERATE) && \
 	  rm -fr $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_USE) && \
@@ -155,7 +174,9 @@
 	src/common/tv_filters \
 	src/emucore \
 	src/emucore/tia \
-	src/emucore/tia/frame-manager
+	src/emucore/tia/frame-manager \
+	src/common/repository/sqlite \
+	src/sqlite
 
 ######################################################################
 # The build rules follow - normally you should have no need to
@@ -223,7 +244,7 @@
 
 $(OBJECT_ROOT)/%.o: %.c
 	$(create_dir)
-	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $@
+	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CFLAGS) $(CPPFLAGS) -c $(<) -o $@
 	$(merge_dep)
 
 $(OBJECT_ROOT_PROFILE_GENERERATE)/%.pgen.o: %.cxx
@@ -231,9 +252,9 @@
 	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@
 	$(merge_dep)
 
-$(OBJECT_ROOT_PROFILE_GENERERATE)/%.pgen.o: %.cxx
-	$(create_dir)
-	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@
+$(OBJECT_ROOT_PROFILE_GENERERATE)/%.pgen.o: %.c
+	$(create_dir)
+	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@
 	$(merge_dep)
 
 $(OBJECT_ROOT_PROFILE_USE)/%.pgo.o: %.cxx $(PROFILE_STAMP)
@@ -241,9 +262,9 @@
 	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@
 	$(merge_dep)
 
-$(OBJECT_ROOT_PROFILE_USE)/%.pgo.o: %.cxx $(PROFILE_STAMP)
-	$(create_dir)
-	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@
+$(OBJECT_ROOT_PROFILE_USE)/%.pgo.o: %.c $(PROFILE_STAMP)
+	$(create_dir)
+	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@
 	$(merge_dep)
 
 else
@@ -257,7 +278,7 @@
 
 $(OBJECT_ROOT)/%.o: %.c
 	$(create_dir)
-	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $@
+	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CFLAGS) $(CPPFLAGS) -c $(<) -o $@
 
 $(OBJECT_ROOT_PROFILE_GENERERATE)/%.o: %.cxx
 	$(create_dir)
@@ -265,7 +286,7 @@
 
 $(OBJECT_ROOT_PROFILE_GENERERATE)/%.o: %.c
 	$(create_dir)
-	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@
+	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@
 
 $(OBJECT_ROOT_PROFILE_USE)/%.o: %.cxx $(PROFILE_STAMP)
 	$(create_dir)
@@ -273,7 +294,7 @@
 
 $(OBJECT_ROOT_PROFILE_USE)/%.o: %.c $(PROFILE_STAMP)
 	$(create_dir)
-	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@
+	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@
 
 endif
 
@@ -319,15 +340,3 @@
 install-strip: install
 	$(STRIP) stella$(EXEEXT)
 
-uninstall:
-	rm -f  "$(DESTDIR)$(BINDIR)/stella$(EXEEXT)"
-	rm -rf "$(DESTDIR)$(DOCDIR)/"
-	rm -f  "$(DESTDIR)$(DATADIR)/applications/stella.desktop"
-	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/16x16/apps/stella.png"
-	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/22x22/apps/stella.png"
-	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/24x24/apps/stella.png"
-	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/32x32/apps/stella.png"
-	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/48x48/apps/stella.png"
-	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/64x64/apps/stella.png"
-	rm -f  "$(DESTDIR)$(DATADIR)/icons/hicolor/128x128/apps/stella.png"
-

=== src/libretro/Makefile ===
--- 
+++ 
@@ -54,10 +54,11 @@
    CXXFLAGS += -DGIT_VERSION=\"$(GIT_VERSION)\"
 endif
 
+GET_STATIC_ARG=$(if $(filter $(shell $(CXX) -print-file-name=$1.a),$1.a),,-static-$1)
 # Unix
 ifneq (,$(findstring unix,$(platform)))
    CXXFLAGS += $(LTO)
-   LDFLAGS += $(LTO) $(PTHREAD_FLAGS) -static-libgcc -static-libstdc++
+   LDFLAGS += $(LTO) $(PTHREAD_FLAGS) $(call GET_STATIC_ARG,libgcc) $(call GET_STATIC_ARG,libstdc++)
    TARGET := $(TARGET_NAME)_libretro.so
    fpic := -fPIC
    ifneq ($(findstring SunOS,$(shell uname -a)),)
@@ -360,4 +361,3 @@
    ProgramFiles86w := $(shell cmd //c "echo %PROGRAMFILES(x86)%")
    ProgramFiles86 := $(shell cygpath "$(ProgramFiles86w)")
 
-   WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Microsoft SDKs\Windows\v10.0)

=== debian/changelog ===
stella (6.5.2-1) unstable; urgency=medium

  * New upstream bug-fix release, merging all our patches.

 -- Stephen Kitt <skitt@debian.org>  Fri, 26 Feb 2021 11:51:58 +0100

=== debian/control ===
--- 
+++ 
@@ -7,9 +7,9 @@
                libpng-dev,
                libsdl2-dev,
                zlib1g-dev
-Standards-Version: 4.5.0
-Vcs-Browser: https://salsa.debian.org/games-team/stella/tree/experimental
-Vcs-Git: https://salsa.debian.org/games-team/stella.git -b experimental
+Standards-Version: 4.5.1
+Vcs-Browser: https://salsa.debian.org/games-team/stella
+Vcs-Git: https://salsa.debian.org/games-team/stella.git
 Homepage: https://stella-emu.github.io
 Rules-Requires-Root: no

## stella 6.5.3

=== debian/changelog ===
stella (6.5.3-1) unstable; urgency=medium

  * Standards-Version 4.6.0, no change required.
  * Upload to unstable.

 -- Stephen Kitt <skitt@debian.org>  Thu, 02 Sep 2021 18:24:53 +0200

stella (6.5.3-1~exp1) experimental; urgency=medium

  * New upstream bug-fix release.

 -- Stephen Kitt <skitt@debian.org>  Sun, 18 Jul 2021 07:38:40 +0200

## stella 6.6

=== Makefile ===
--- 
+++ 
@@ -61,11 +61,11 @@
 endif
 
 ifdef CLANG_WARNINGS
-  EXTRA_WARN=-Weverything -Wno-c++17-extensions  -Wno-c++98-compat-pedantic \
+  EXTRA_WARN=-Weverything -Wno-c++98-compat-pedantic -Wno-unknown-warning-option \
     -Wno-switch-enum -Wno-conversion -Wno-covered-switch-default \
     -Wno-inconsistent-missing-destructor-override -Wno-float-equal \
     -Wno-exit-time-destructors -Wno-global-constructors -Wno-weak-vtables \
-    -Wno-four-char-constants -Wno-padded
+    -Wno-four-char-constants -Wno-padded -Wno-reserved-identifier
 
   CXXFLAGS+= $(EXTRA_WARN)
   CFLAGS+= $(EXTRA_WARN)
@@ -338,5 +338,3 @@
 	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-128x128.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/128x128/apps/stella.png"
 
 install-strip: install
-	$(STRIP) stella$(EXEEXT)
-

=== debian/changelog ===
stella (6.6-1) unstable; urgency=medium

  * New upstream release.
  * Add upstream metadata.

 -- Stephen Kitt <skitt@debian.org>  Fri, 19 Nov 2021 09:04:41 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                libpng-dev,
                libsdl2-dev,
                zlib1g-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/games-team/stella
 Vcs-Git: https://salsa.debian.org/games-team/stella.git
 Homepage: https://stella-emu.github.io

## stella 6.7%2Bdfsg

=== Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
 ##  SS  SS   tt   ee      ll   ll  aa  aa
 ##   SSSS     ttt  eeeee llll llll  aaaaa
 ##
-## Copyright (c) 1995-2021 by Bradford W. Mott, Stephen Anthony
+## Copyright (c) 1995-2022 by Bradford W. Mott, Stephen Anthony
 ## and the Stella Team
 ##
 ## See the file "License.txt" for information on usage and redistribution of
@@ -65,7 +65,8 @@
     -Wno-switch-enum -Wno-conversion -Wno-covered-switch-default \
     -Wno-inconsistent-missing-destructor-override -Wno-float-equal \
     -Wno-exit-time-destructors -Wno-global-constructors -Wno-weak-vtables \
-    -Wno-four-char-constants -Wno-padded -Wno-reserved-identifier
+    -Wno-four-char-constants -Wno-padded -Wno-reserved-identifier \
+    -Wno-duplicate-enum
 
   CXXFLAGS+= $(EXTRA_WARN)
   CFLAGS+= $(EXTRA_WARN)
@@ -78,8 +79,8 @@
 endif
 
 ifdef DEBUG
-  CXXFLAGS += -g
-  CFLAGS += -g
+  CXXFLAGS += -g -Wp,-D_GLIBCXX_DEBUG
+  CFLAGS += -g -Wp,-D_GLIBCXX_DEBUG
 else
   ifdef HAVE_GCC
     CXXFLAGS+= -fomit-frame-pointer
@@ -145,8 +146,8 @@
 	CFLAGS_PROFILE_USE += -fprofile-use -fprofile-dir=$(PROFILE_OUT)
 	LDFLAGS_PROFILE_GENERATE += -fprofile-generate
 	STELLA_PROFILE_GENERATE := $(STELLA_PROFILE_GENERATE) && \
-	  rm -fr $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_USE) && \
-		mv $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_GENERERATE) $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_USE)
+	  (rm -fr $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_USE) || true) && \
+		(mv $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_GENERERATE) $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_USE) || true)
 endif
 
 all: $(EXECUTABLE)
@@ -175,8 +176,7 @@
 	src/emucore \
 	src/emucore/tia \
 	src/emucore/tia/frame-manager \
-	src/common/repository/sqlite \
-	src/sqlite
+	src/common/repository/sqlite
 
 ######################################################################
 # The build rules follow - normally you should have no need to
@@ -335,6 +335,3 @@
 	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-32x32.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/32x32/apps/stella.png"
 	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-48x48.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/48x48/apps/stella.png"
 	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-64x64.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/64x64/apps/stella.png"
-	$(INSTALL) -c -m 644 "$(srcdir)/src/common/stella-128x128.png" "$(DESTDIR)$(DATADIR)/icons/hicolor/128x128/apps/stella.png"
-
-install-strip: install

## stella 6.7+dfsg

=== debian/changelog ===
stella (6.7+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 4.6.1, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 18 Jun 2022 13:34:08 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                libpng-dev,
                libsdl2-dev,
                zlib1g-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/games-team/stella
 Vcs-Git: https://salsa.debian.org/games-team/stella.git
 Homepage: https://stella-emu.github.io
